---
title: <display-internal>
slug: Web/CSS/display-internal
tags:
  - CSS
  - CSS Data Type
  - CSS Display
  - Data Type
  - Reference
  - display-internal
---
<div>{{CSSRef}}</div>

<p class="summary">Some layout models such as <code>table</code> and <code>ruby</code> have a complex internal structure, with several different roles that their children and descendants can fill. This page defines those "internal" display values, which only have meaning within that particular layout mode.</p>

<h2 id="Syntax">Syntax</h2>

<p>Valid <code>&lt;display-internal&gt;</code> values:</p>

<dl>
 <dt><code>table-row-group</code></dt>
 <dd>These elements behave like {{HTMLElement("tbody")}} HTML elements.</dd>
 <dt><code>table-header-group</code></dt>
 <dd>These elements behave like {{HTMLElement("thead")}} HTML elements.</dd>
 <dt><code>table-footer-group</code></dt>
 <dd>These elements behave like {{HTMLElement("tfoot")}} HTML elements.</dd>
 <dt><code>table-row</code></dt>
 <dd>These elements behave like {{HTMLElement("tr")}} HTML elements.</dd>
 <dt><code>table-cell</code></dt>
 <dd>These elements behave like {{HTMLElement("td")}} HTML elements.</dd>
 <dt><code>table-column-group</code></dt>
 <dd>These elements behave like {{HTMLElement("colgroup")}} HTML elements.</dd>
 <dt><code>table-column</code></dt>
 <dd>These elements behave like {{HTMLElement("col")}} HTML elements.</dd>
 <dt><code>table-caption</code></dt>
 <dd>These elements behave like {{HTMLElement("caption")}} HTML elements.</dd>
 <dt><code>ruby-base</code> {{Experimental_Inline}}</dt>
 <dd>These elements behave like {{HTMLElement("rb")}} HTML elements.</dd>
 <dt><code>ruby-text</code> {{Experimental_Inline}}</dt>
 <dd>These elements behave like {{HTMLElement("rt")}} HTML elements.</dd>
 <dt><code>ruby-base-container</code> {{Experimental_Inline}}</dt>
 <dd>These elements behave like {{HTMLElement("rbc")}} HTML elements generated as anonymous boxes.</dd>
 <dt><code>ruby-text-container</code> {{Experimental_Inline}}</dt>
 <dd>These elements behave like {{HTMLElement("rtc")}} HTML elements.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="CSS_tables_example">CSS tables example</h3>

<p>The following example demonstrates laying out a simple form using CSS table layout.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;main&gt;
  &lt;div&gt;
    &lt;label for="name"&gt;Name&lt;/label&gt;
    &lt;input type="text" id="name" name="name"&gt;
  &lt;/div&gt;
  &lt;div&gt;
    &lt;label for="age"&gt;Age&lt;/label&gt;
    &lt;input type="text" id="age" name="age"&gt;
  &lt;/div&gt;
&lt;/main&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">main {
  display: table;
}

div {
  display: table-row;
}

label, input {
  display: table-cell;
  margin: 5px;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('CSS_tables_example', '100%', 100)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Display', '#typedef-display-internal', 'display-internal')}}</td>
   <td>{{Spec2('CSS3 Display')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<h3 id="Support_of_table_values">Support of table values</h3>

<p><code>table</code>, <code>table-cell</code>, <code>table-column</code>, <code>table-column-group</code>, <code>table-footer-group</code>, <code>table-header-group</code>, <code>table-row</code>, and <code>table-row-group</code></p>

<p>{{Compat("css.properties.display.table_values", 10)}}</p>

<h3 id="Support_of_ruby_values">Support of ruby values</h3>

<p><code>ruby</code>, <code>ruby-base</code>, <code>ruby-base-container</code>, <code>ruby-text</code>, and <code>ruby-text-container</code></p>

<p>{{Compat("css.properties.display.ruby_values", 10)}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("display")}}
  <ul>
   <li>{{CSSxRef("&lt;display-outside&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-inside&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-listitem&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-box&gt;")}}</li>
   <li>{{CSSxRef("&lt;display-legacy&gt;")}}</li>
  </ul>
 </li>
</ul>
